;*********************************************************************************************
;TWI (I2C) Bus zum Stellen der RTC Werte fr Sekunden (nur auf 00),
;und Minuten 
;*********************************************************************************************
Sek_Write:								;Anfangswerte auslesen und speichern
	ldi		tmp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, tmp					;Startbedingung ausgeben
	rcall	WarteAufRTC					;Warten bis TWINT = 0

	ldi		tempdat,TWIDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Slaveadresse ausgeben
	rcall	WarteAufRTC	

	ldi 	tempdat,Sek_Register			
	out		TWDR, tempdat				;Registeradresse laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Registeradresse ausgeben
	rcall	WarteAufRTC	

	ldi 	tempdat, 0x00			
	out		TWDR, tempdat				;Sekunden laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Sekunden ausgeben
	rcall	WarteAufRTC	

;STOP
	ldi		tmp, (1<<TWINT | 1<<TWSTO | 1<<TWEN)
	out		TWCR, tmp					;Stoppbedingung ausgeben
	rjmp	Mainloop

;**************************************************************************
Min_Write:
	ldi		tmp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, tmp					;Startbedingung ausgeben
	rcall	WarteAufRTC					;Warten bis TWINT = 0

	ldi		tempdat,TWIDispAdr + TWIwr
	out		TWDR, tempdat				;Slaveadresse "schreiben" laden
	ldi		tmp, (1<<TWINT | 1<<TWEN)
	out		TWCR, tmp					;Slaveadresse ausgeben
	rcall	WarteAufRTC
	
	ldi 	tempdat,Min_Register			
	out		TWDR, tempdat				;Registeradresse "Minuten" laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Registeradresse ausgeben
	rcall	WarteAufRTC	

	ldi		tmp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, tmp					;Startbedingung ausgeben
	rcall	WarteAufRTC					;Warten bis TWINT = 0

	ldi		tempdat,TWIDispAdr + TWIrd
	out		TWDR, tempdat				;Slaveadresse "lesen" laden
	ldi		tmp, (1<<TWINT | 1<<TWEN)
	out		TWCR, tmp					;Slaveadresse ausgeben
	rcall	WarteAufRTC
	
	ldi		tmp, (1<<TWINT | 1<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, tmp
	rcall	WarteAufRTC

	in		tempdat, TWDR				;Minuten auslesen
	ldi		tmp, (1<<TWINT | 0<<TWEA | 1<<TWEN) ;ACK fr mehrere Datenbytes senden
	out		TWCR, tmp						
	rcall	WarteAufRTC	

	mov		tmp,tempdat
	andi	tmp, 0x0F
	cpi		tmp, 9
	breq	Korr
	inc		tempdat						;Minuten um eins erhhen
	cpi		tempdat, 0x60				;prfen ob 60 erreicht
	breq	Null
	rjmp	Ausgabe

Korr:
	inc		tempdat
	subi	tempdat, -6					;wenn 9, dann BCD korrigieren
	cpi		tempdat, 0x60
	breq	Null
	rjmp	Ausgabe	

Null:
	clr		tempdat

Ausgabe:
	ldi		tmp, (1<<TWINT | 1<<TWSTA | 1<<TWEN)
	out		TWCR, tmp					;Startbedingung ausgeben
	rcall	WarteAufRTC					;Warten bis TWINT = 0

	ldi		tmp, TWIDispAdr + TWIwr
	out		TWDR, tmp					;Slaveadresse "schreiben" laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Slaveadresse ausgeben
	rcall	WarteAufRTC	

	ldi 	tmp, Min_Register			
	out		TWDR, tmp					;Registeradresse "Minuten" laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Registeradresse ausgeben
	rcall	WarteAufRTC	

	mov 	tmp, tempdat			
	out		TWDR, tmp					;Minuten laden
	ldi		tmp, (1<<TWINT) | (1<<TWEN)
	out		TWCR, tmp					;Minuten ausgeben
	rcall	WarteAufRTC	

;STOP
	ldi		tmp, (1<<TWINT | 1<<TWSTO | 1<<TWEN)
	out		TWCR, tmp					;Stoppbedingung ausgeben

	rjmp	Lesen
